// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_

#include "microstrain_inertial_msgs/msg/detail/status__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const microstrain_inertial_msgs::msg::Status & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: device_model
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "device_model: ";
    value_to_yaml(msg.device_model, out);
    out << "\n";
  }

  // member: status_selector
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_selector: ";
    value_to_yaml(msg.status_selector, out);
    out << "\n";
  }

  // member: status_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_flags: ";
    value_to_yaml(msg.status_flags, out);
    out << "\n";
  }

  // member: system_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "system_state: ";
    value_to_yaml(msg.system_state, out);
    out << "\n";
  }

  // member: system_timer_ms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "system_timer_ms: ";
    value_to_yaml(msg.system_timer_ms, out);
    out << "\n";
  }

  // member: gps_power_on
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_power_on: ";
    value_to_yaml(msg.gps_power_on, out);
    out << "\n";
  }

  // member: num_gps_pps_triggers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "num_gps_pps_triggers: ";
    value_to_yaml(msg.num_gps_pps_triggers, out);
    out << "\n";
  }

  // member: last_gps_pps_trigger_ms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_gps_pps_trigger_ms: ";
    value_to_yaml(msg.last_gps_pps_trigger_ms, out);
    out << "\n";
  }

  // member: imu_stream_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_stream_enabled: ";
    value_to_yaml(msg.imu_stream_enabled, out);
    out << "\n";
  }

  // member: gps_stream_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_stream_enabled: ";
    value_to_yaml(msg.gps_stream_enabled, out);
    out << "\n";
  }

  // member: filter_stream_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "filter_stream_enabled: ";
    value_to_yaml(msg.filter_stream_enabled, out);
    out << "\n";
  }

  // member: imu_dropped_packets
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_dropped_packets: ";
    value_to_yaml(msg.imu_dropped_packets, out);
    out << "\n";
  }

  // member: gps_dropped_packets
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_dropped_packets: ";
    value_to_yaml(msg.gps_dropped_packets, out);
    out << "\n";
  }

  // member: filter_dropped_packets
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "filter_dropped_packets: ";
    value_to_yaml(msg.filter_dropped_packets, out);
    out << "\n";
  }

  // member: com1_port_bytes_written
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com1_port_bytes_written: ";
    value_to_yaml(msg.com1_port_bytes_written, out);
    out << "\n";
  }

  // member: com1_port_bytes_read
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com1_port_bytes_read: ";
    value_to_yaml(msg.com1_port_bytes_read, out);
    out << "\n";
  }

  // member: com1_port_write_overruns
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com1_port_write_overruns: ";
    value_to_yaml(msg.com1_port_write_overruns, out);
    out << "\n";
  }

  // member: com1_port_read_overruns
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "com1_port_read_overruns: ";
    value_to_yaml(msg.com1_port_read_overruns, out);
    out << "\n";
  }

  // member: imu_parser_errors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_parser_errors: ";
    value_to_yaml(msg.imu_parser_errors, out);
    out << "\n";
  }

  // member: imu_message_count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_message_count: ";
    value_to_yaml(msg.imu_message_count, out);
    out << "\n";
  }

  // member: imu_last_message_ms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "imu_last_message_ms: ";
    value_to_yaml(msg.imu_last_message_ms, out);
    out << "\n";
  }

  // member: gps_parser_errors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_parser_errors: ";
    value_to_yaml(msg.gps_parser_errors, out);
    out << "\n";
  }

  // member: gps_message_count
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_message_count: ";
    value_to_yaml(msg.gps_message_count, out);
    out << "\n";
  }

  // member: gps_last_message_ms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_last_message_ms: ";
    value_to_yaml(msg.gps_last_message_ms, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const microstrain_inertial_msgs::msg::Status & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::Status>()
{
  return "microstrain_inertial_msgs::msg::Status";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::Status>()
{
  return "microstrain_inertial_msgs/msg/Status";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::Status>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::Status>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::Status>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__STATUS__TRAITS_HPP_
