// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/GetAccelBiasModel.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_ACCEL_BIAS_MODEL__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_ACCEL_BIAS_MODEL__TRAITS_HPP_

#include "microstrain_inertial_msgs/srv/detail/get_accel_bias_model__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const microstrain_inertial_msgs::srv::GetAccelBiasModel_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const microstrain_inertial_msgs::srv::GetAccelBiasModel_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>()
{
  return "microstrain_inertial_msgs::srv::GetAccelBiasModel_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>()
{
  return "microstrain_inertial_msgs/srv/GetAccelBiasModel_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'noise_vector'
// Member 'beta_vector'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const microstrain_inertial_msgs::srv::GetAccelBiasModel_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: noise_vector
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "noise_vector:\n";
    to_yaml(msg.noise_vector, out, indentation + 2);
  }

  // member: beta_vector
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "beta_vector:\n";
    to_yaml(msg.beta_vector, out, indentation + 2);
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const microstrain_inertial_msgs::srv::GetAccelBiasModel_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>()
{
  return "microstrain_inertial_msgs::srv::GetAccelBiasModel_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>()
{
  return "microstrain_inertial_msgs/srv/GetAccelBiasModel_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetAccelBiasModel>()
{
  return "microstrain_inertial_msgs::srv::GetAccelBiasModel";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetAccelBiasModel>()
{
  return "microstrain_inertial_msgs/srv/GetAccelBiasModel";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetAccelBiasModel>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetAccelBiasModel>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::GetAccelBiasModel>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::GetAccelBiasModel_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::GetAccelBiasModel_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_ACCEL_BIAS_MODEL__TRAITS_HPP_
