// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:srv/GetComplementaryFilter.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_COMPLEMENTARY_FILTER__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_COMPLEMENTARY_FILTER__TRAITS_HPP_

#include "microstrain_inertial_msgs/srv/detail/get_complementary_filter__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const microstrain_inertial_msgs::srv::GetComplementaryFilter_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const microstrain_inertial_msgs::srv::GetComplementaryFilter_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>()
{
  return "microstrain_inertial_msgs::srv::GetComplementaryFilter_Request";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>()
{
  return "microstrain_inertial_msgs/srv/GetComplementaryFilter_Request";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const microstrain_inertial_msgs::srv::GetComplementaryFilter_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: north_comp_enable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "north_comp_enable: ";
    value_to_yaml(msg.north_comp_enable, out);
    out << "\n";
  }

  // member: up_comp_enable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "up_comp_enable: ";
    value_to_yaml(msg.up_comp_enable, out);
    out << "\n";
  }

  // member: north_comp_time_const
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "north_comp_time_const: ";
    value_to_yaml(msg.north_comp_time_const, out);
    out << "\n";
  }

  // member: up_comp_time_const
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "up_comp_time_const: ";
    value_to_yaml(msg.up_comp_time_const, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const microstrain_inertial_msgs::srv::GetComplementaryFilter_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>()
{
  return "microstrain_inertial_msgs::srv::GetComplementaryFilter_Response";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>()
{
  return "microstrain_inertial_msgs/srv/GetComplementaryFilter_Response";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<microstrain_inertial_msgs::srv::GetComplementaryFilter>()
{
  return "microstrain_inertial_msgs::srv::GetComplementaryFilter";
}

template<>
inline const char * name<microstrain_inertial_msgs::srv::GetComplementaryFilter>()
{
  return "microstrain_inertial_msgs/srv/GetComplementaryFilter";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::srv::GetComplementaryFilter>
  : std::integral_constant<
    bool,
    has_fixed_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>::value &&
    has_fixed_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>::value
  >
{
};

template<>
struct has_bounded_size<microstrain_inertial_msgs::srv::GetComplementaryFilter>
  : std::integral_constant<
    bool,
    has_bounded_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>::value &&
    has_bounded_size<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>::value
  >
{
};

template<>
struct is_service<microstrain_inertial_msgs::srv::GetComplementaryFilter>
  : std::true_type
{
};

template<>
struct is_service_request<microstrain_inertial_msgs::srv::GetComplementaryFilter_Request>
  : std::true_type
{
};

template<>
struct is_service_response<microstrain_inertial_msgs::srv::GetComplementaryFilter_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__SRV__DETAIL__GET_COMPLEMENTARY_FILTER__TRAITS_HPP_
