// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from microstrain_inertial_msgs:msg/RTKStatus.idl
// generated code does not contain a copyright notice

#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__TRAITS_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__TRAITS_HPP_

#include "microstrain_inertial_msgs/msg/detail/rtk_status__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const microstrain_inertial_msgs::msg::RTKStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: gps_tow
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_tow: ";
    value_to_yaml(msg.gps_tow, out);
    out << "\n";
  }

  // member: gps_week
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_week: ";
    value_to_yaml(msg.gps_week, out);
    out << "\n";
  }

  // member: epoch_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "epoch_status: ";
    value_to_yaml(msg.epoch_status, out);
    out << "\n";
  }

  // member: dongle_version
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_version: ";
    value_to_yaml(msg.dongle_version, out);
    out << "\n";
  }

  // member: dongle_modem_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_modem_state: ";
    value_to_yaml(msg.dongle_modem_state, out);
    out << "\n";
  }

  // member: dongle_connection_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_connection_type: ";
    value_to_yaml(msg.dongle_connection_type, out);
    out << "\n";
  }

  // member: dongle_rssi
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_rssi: ";
    value_to_yaml(msg.dongle_rssi, out);
    out << "\n";
  }

  // member: dongle_signal_quality
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_signal_quality: ";
    value_to_yaml(msg.dongle_signal_quality, out);
    out << "\n";
  }

  // member: dongle_tower_change_indicator
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_tower_change_indicator: ";
    value_to_yaml(msg.dongle_tower_change_indicator, out);
    out << "\n";
  }

  // member: dongle_nmea_timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_nmea_timeout: ";
    value_to_yaml(msg.dongle_nmea_timeout, out);
    out << "\n";
  }

  // member: dongle_server_timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_server_timeout: ";
    value_to_yaml(msg.dongle_server_timeout, out);
    out << "\n";
  }

  // member: dongle_rtcm_timeout
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_rtcm_timeout: ";
    value_to_yaml(msg.dongle_rtcm_timeout, out);
    out << "\n";
  }

  // member: dongle_out_of_range
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_out_of_range: ";
    value_to_yaml(msg.dongle_out_of_range, out);
    out << "\n";
  }

  // member: dongle_corrections_unavailable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dongle_corrections_unavailable: ";
    value_to_yaml(msg.dongle_corrections_unavailable, out);
    out << "\n";
  }

  // member: gps_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gps_correction_latency: ";
    value_to_yaml(msg.gps_correction_latency, out);
    out << "\n";
  }

  // member: glonass_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "glonass_correction_latency: ";
    value_to_yaml(msg.glonass_correction_latency, out);
    out << "\n";
  }

  // member: galileo_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "galileo_correction_latency: ";
    value_to_yaml(msg.galileo_correction_latency, out);
    out << "\n";
  }

  // member: beidou_correction_latency
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "beidou_correction_latency: ";
    value_to_yaml(msg.beidou_correction_latency, out);
    out << "\n";
  }

  // member: raw_status_flags
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "raw_status_flags: ";
    value_to_yaml(msg.raw_status_flags, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const microstrain_inertial_msgs::msg::RTKStatus & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<microstrain_inertial_msgs::msg::RTKStatus>()
{
  return "microstrain_inertial_msgs::msg::RTKStatus";
}

template<>
inline const char * name<microstrain_inertial_msgs::msg::RTKStatus>()
{
  return "microstrain_inertial_msgs/msg/RTKStatus";
}

template<>
struct has_fixed_size<microstrain_inertial_msgs::msg::RTKStatus>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<microstrain_inertial_msgs::msg::RTKStatus>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<microstrain_inertial_msgs::msg::RTKStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__RTK_STATUS__TRAITS_HPP_
